1010 '***** PROGRAMA DM2R: DIMENSIONAMIENTO SEC.RECTANG. FLEXOCOM. ESVIADA
1020 '***** Autores: F.Morn Cabr - A.Garca Meseguer - P.Jimnez Montoya
1030 '***** Ref: Hormign Armado, Montoya-Meseguer-Morn, Ed.G.Gili, Barna
1040 '***** Lenguaje: GW BASIC para compatibles IBM-PC/XT/AT/PS2 en MS-DOS

1050 DEFINT I-J, N: DIM N(4), K(7)
1060 K(1) = .0581: K(2) = .2352: K(3) = .338: K(4) = .5  '*** Coefs. Chebyshev
1070 K(7) = .9419: K(6) = .7648: K(5) = .662
1080 FCD = 1750 * .9 / 1.5: FYD = 4.1 / 1.1: CLS : PRINT '*** Resist. defecto

1090 PRINT "        DIMENSIONAMIENTO DE SOPORTES EN FLEXOCOMPRESION ESVIADA"
1100 T$ = "   Seccin rectangular. Mtodo Parbola-Rectngulo. Clculo riguroso"
1110 S$ = "               Capacidad mecnica por barra U =###.## t;   = ##.## mm"
1120 PRINT : PRINT T$
1130 T$ = "1=resistencias  2=escuadra  3=recubr.  4=Cd. Armado  5=solicit.  6=fin"
1140 COLOR 0, 7: LOCATE 25, 1: PRINT T$; : COLOR 7, 0: PRINT

1150 WHILE TAREA% < 6
1160    INPUT "                                 Elige opcin = ", TAREA%
1170    IF TAREA% = 1 THEN GOSUB 1230            '*** Resistencias
1180    IF TAREA% = 2 THEN GOSUB 1260            '*** Escuadria
1190    IF TAREA% = 3 THEN GOSUB 1290            '*** Recubrimiento
1200    IF TAREA% = 4 THEN GOSUB 1330            '*** Cod.Armado
1210    IF TAREA% = 5 THEN GOSUB 1470            '*** Solicitacion
1220 WEND: END

1230 '*** Resistencias:
1240    INPUT "  Resistencias de clculo:  fcd, fyd (kp/cm2) = ", FCD, FYD
1250    FCD = 10 * FCD: FYD = FYD / 1000        '*** Paso unidades de calculo

1260 '*** Escuadria:
1270    INPUT "        Escuadra de la seccin:  hx, hy (cm) = ", HX, HY
1280    HX = HX / 100: HY = HY / 100             '*** Paso a metros

1290 '*** Recubrimiento:
1300   INPUT "    Recubrimiento mecnico estimado:  r (cm)  = ", RMEC
1310    RMEC = RMEC / 100
1320    FACN = .85 * FCD * HX * HY: FACMY = FACN * HX: FACMX = FACN * HY

1330 '*** Cod.Armado:
1340    INPUT "          Cdigo de Armado:  C A (dos cifras) = ", CODA%
1350    NX = CODA% \ 10: NY = CODA% - 10 * NX
1360    NBAR = 2 * (NX + NY) - 4                 '*** Num.barras totales
1370    N(1) = NX: N(2) = NX + NY - 1            '*** Barras de esquina
1380    N(3) = N(2) + NX - 1: N(4) = NBAR
1390    CX = RMEC / HX: CY = RMEC / HY           '*** Recubr. reducidos
1400    EXMIN = HX / 20: IF EXMIN < .02 THEN EXMIN = .02'*** Excentric. mnimas
1410    EYMIN = HY / 20: IF EYMIN < .02 THEN EYMIN = .02
1420    SX = (1 - 2 * CX) / (NX - 1): SY = (1 - 2 * CY) / (NY - 1)'*** Separac. barras reduc.
1430    X = .5 - CX: Y = .5 - CY                 '*** Coord. reduc. 1a barra
1440    DX = -SX: DY = 0                         '*** Paso a la 2a barra
1450    RAG = 180 / 3.14159265#                  '*** Paso radianes/grados
1460    UMIN = 40 * HX * HY * FYD / NBAR         '*** Cap.mec.mn.por barra

1470 '*** Solicitacion:
1480    INPUT "Solic. act.de clculo: Mxd(hy), Myd(mt), Nd(t)= ", MXD, MYD, ND!
1490    IF MXD < 0 THEN MXD = -MXD               '*** Momentos negativos
1500    IF MYD < 0 THEN MYD = -MYD
1510    IF ND! < 1 THEN ND! = 1                  '*** Axil mnimo

1520    EX = MYD / ND!: EY = MXD / ND!           '*** Excentricidades
1530    FI = 90                                  '*** Angulo inicial
1540    IF EX >= EXMIN OR EY >= EYMIN THEN 1610  '*** Excentr. mnimas
1550      IF HX >= HY THEN 1590
1560         EX = EXMIN: MYD = EX * ND!
1570         EY = 0:     MXD = 0
1580      GOTO 1620
1590         EY = EYMIN: MXD = EY * ND!
1600         EX = 0:     MYD = 0

1610    IF EX <> 0 THEN FI = RAG * ATN(EY / EX * HX / HY)
1620    BET = FI: XI = .7: GOSUB 1880             '*** Valores iniciales
1630    WHILE ABS(ERRN) > .0001 OR ABS(ERRM) > .001
1640      XI1 = XI: E5 = ERRN: XI = XI1 + .01     '*** Nuevo valor de xi
1650      WHILE ABS(ERRN) > .0001
1660        GOSUB 1880                            '*** Subr.pral. Resultante
1670        DXI = (XI1 - XI) / (E5 - ERRN) * ERRN '*** Correccin de xi
1680        IF ABS(DXI) > .2 THEN DXI = .2 * SGN(DXI)'*** Valor mx. correccin
1690        IF DXI * ERRN > 0 THEN DXI = -DXI     '*** Cambio de sentido
1700        XI1 = XI: E5 = ERRN: XI = XI - DXI    '*** Nuevos valores
1710        IF XI > 2 THEN XI = 2                 '*** Valores extremos
1720        IF XI < 0 THEN XI = .01
1730      WEND                                    '*** Nuevo tanteo de xi
1740      BET1 = BET: E6 = ERRM: BET = BET1 + 1   '*** Nuevo valor de beta
1750      WHILE ABS(ERRM) > .001
1760        GOSUB 1880                            '*** Subr.pral. Resultante
1770        DBET = (BET1 - BET) / (E6 - ERRM) * ERRM '*** Correccin de beta
1780        IF ABS(DBET) > 36 THEN DBET = 36 * SGN(DBET)'*** Valor mx. correccin
1790        BET1 = BET: E6 = ERRM: BET = BET - DBET  '*** Nuevos valores
1800        IF BET > 90 THEN BET = 90                '*** Valores extremos
1810        IF BET < 0 THEN BET = 0
1820      WEND                                       '*** Nuevo tanteo de beta
1830    WEND

1840    UBAR = ABAR * FYD: IF UBAR < UMIN THEN UBAR = UMIN' Cap.mecnica por barra
1850    FI = 20 * SQR(UBAR / 3.1416 / FYD)          '*** Dimetro
1860    PRINT USING S$; UBAR, FI: PRINT
1870    RETURN                                      '*** Comn a las 5 Subr.

1880 '*** Resultante:                   '*** Subrutina pral: clculo dada f.n.
1890    IF BET <= 45 THEN T = TAN(BET / RAG) ELSE T = TAN((90 - BET) / RAG)
1900    T1 = 1 / (1 + T): T2 = 1 - T1
1910    C = 1 / SQR(1 + T * T): S = T * C            '*** Coseno y seno
1920    D = ((1 - CX) * C + (1 - CY) * S) / (C + S)  '*** Canto til oblicuo

1930    IF XI > 0 THEN 1950
1940       EPSC = 100 * XI: EPSS = -100: GOTO 2030   '*** Dominio 1
1950    IF XI > .259 * D THEN 1980
1960       EPSC = 100 * XI / (D - XI)                '*** Dominio 2
1970       EPSS = -100: GOTO 2030
1980    IF XI > 1 THEN 2010
1990       EPSC = 35                                 '*** Dominios 3 y 4
2000       EPSS = 35 * (XI - D) / XI: GOTO 2030
2010    EPSC = 50 - 15 * XI: EPS = 35 * (1 - D)      '*** Dominio 5
2020    EPSS = EPS + (XI - 1) * (20 - EPS)

2030    DEPS = (EPSC - EPSS) / D / (C + S)
2040    NC! = 0: MXC = 0: MYC = 0                    '*** Resultantes hormign
2050    IF XI < T2 THEN X1 = XI ELSE X1 = T2
2060    GOSUB 2490                                   '*** Subr. Triangulo
2070    IF XI <= T2 THEN 2130
2080      IF XI < T1 THEN X1 = XI ELSE X1 = T1
2090      GOSUB 2670                                 '*** Subr. Paralelogramo
2100      IF XI <= T1 THEN 2130
2110        IF XI < 1 THEN X1 = XI ELSE X1 = 1
2120        GOSUB 2820                               '*** Subr. Trapecio

2130    IF BET <= 45 THEN 2160
2140       M3 = MYC: MYC = MXC: MXC = M3
2150       T = S: S = C: C = T                       '*** Cambio X por Y

2160    NC! = NC! * FACN: MXC = MXC * FACMX
2170    MYC = MYC * FACMY                            '*** Paso reducido a real

2180    NS! = 0: MXS = 0: MYS = 0
2190    U = CX * C + CY * S: DU = C * SX             '*** 1a barra armadura
2200    FOR I = 1 TO NBAR                            '*** Resultantes armaduras
2210        EPS = EPSC - U * DEPS                    '*** Deformacin barra
2220        SIG = .21 * EPS                          '*** Tensin
2230        IF SIG < -FYD THEN SIG = -FYD            '*** Limitaciones tensin
2240        IF SIG > FYD THEN SIG = FYD
2250        NS! = NS! + SIG
2260        MXS = MXS + SIG * Y
2270        MYS = MYS + SIG * X
2280        IF I = N(1) THEN DX = 0: DY = -SY: DU = S * SY   '*** Esquinas
2290        IF I = N(2) THEN DX = SX: DY = 0: DU = -C * SX
2300        IF I = N(3) THEN DX = 0: DY = SY: DU = -S * SY
2310        X = X + DX: Y = Y + DY: U = U + DU      '*** Coordenadas y profund.
2320    NEXT I                                      '*** Barra siguiente
2330    DX = -SX: DY = 0                            '*** 1a barra armadura
2340    MXS = MXS * HY: MYS = MYS * HX              '*** Paso reducido a real

2350    IF ABS(NS!) <= .1 THEN 2370
2360       ABAR = (ND! - NC!) / NS!: GOTO 2400      '*** Area barra
2370    IF ABS(MXS) <= .1 THEN 2390
2380       ABAR = (MXD - MXC) / MXS: GOTO 2400
2390    ABAR = (MYD - MYC) / MYS

2400    NR! = ND! - NC!: MXR = MXD - MXC            '*** Dif. para el acero
2410    MYR = MYD - MYC
2420    IF ABS(MYD) > ABS(MXD) THEN 2460
2430      ERRN = (NR! - MXR * NS! / MXS) / ND!      '*** Error de axil
2440      ERRM = (MXR * MYS / MXS - MYR) / MXD      '*** Error de momento
2450    GOTO 2480
2460      ERRN = (NR! - MYR * NS! / MYS) / ND!
2470      ERRM = (MXR - MYR * MXS / MYS) / MYD
2480    RETURN

2490 '*** Triangulo:                            '*** Resultante hn. tringulo
2500   IF T2 = 0 THEN RETURN
2510   HT = S * X1 / T2                            '*** Altura del tringulo
2520   FOR I = 1 TO 7
2530       U = K(I) * HT                           '*** Prof. de la franja
2540       EPS = EPSC - U * DEPS                   '*** Deformacin hormign
2550       SIG = 1                                 '*** Tensin relativa
2560       IF EPS < 20 THEN AUX = 1 - EPS / 20: SIG = 1 - AUX * AUX
2570       SIG = SIG * K(I)                        '*** Axil franja
2580       NC! = NC! + SIG
2590       MXC = MXC + SIG * (1 - U / S)
2600       MYC = MYC + SIG * (1 - U / C)
2610  NEXT I
2620  FAC = HT * HT / S / C / 14                   '*** Factor
2630  NC! = 2 * NC! * FAC
2640  MXC = MXC * FAC
2650  MYC = MYC * FAC
2660  RETURN

2670 '*** Paralelogramo:                       '*** Resultante zona paralelog.
2680 IF T2 = 0 THEN HT = X1 ELSE HT = S * (X1 / T2 - 1)  '*** Altura paralel.
2690 NP! = 0: MY = 0: X0 = (1 - T) / 2             '*** Abscisa 1a franja
2700 FOR I = 1 TO 7
2710      U = S + K(I) * HT                        '*** Prof. de la franja
2720      EPS = EPSC - U * DEPS                    '*** Deformacin hormign
2730      SIG = 1                                  '*** Tensin relativa
2740      IF EPS < 20 THEN AUX = 1 - EPS / 20: SIG = 1 - AUX * AUX
2750      NP! = NP! + SIG                          '*** Axil franja
2760      MY = MY + SIG * (X0 - (U - S) / C)
2770  NEXT I
2780  FAC = HT / C / 7                             '*** Factor
2790  NC! = NC! + NP! * FAC
2800  MYC = MYC + MY * FAC
2810  RETURN

2820 '*** Trapecio:                             '*** Resultante zona trapecio
2830  IF T2 = 0 THEN RETURN
2840  HT = (C + S) * X1 - C                        '*** Altura del trapecio
2850  NP! = 0: MX = 0: MY = 0
2860  FOR I = 1 TO 7
2870      U = C + K(I) * HT                        '*** Prof. de la franja
2880      EPS = EPSC - U * DEPS                    '*** Deformacin hormign
2890      SIG = 1                                  '*** Tensin relativa
2900      IF EPS < 20 THEN AUX = 1 - EPS / 20: SIG = 1 - AUX * AUX
2910      SIG = SIG * (S - K(I) * HT)              '*** Axil franja
2920      NP! = NP! + SIG
2930      MX = MX + SIG * (C - U) / S
2940      MY = MY + SIG * (S - U) / C
2950  NEXT I
2960  FAC = HT / S / C / 14                        '*** Factor
2970  NC! = NC! + NP! * 2 * FAC
2980  MXC = MXC + MX * FAC
2990  MYC = MYC + MY * FAC
3000  RETURN
