1010 '***** PROGRAMA CM2R: COMPROBACION SECCION RECTANG. FLEXOCOM. ESVIADA
1020 '***** Autores: F.Morn Cabr - A.Garca Meseguer - P.Jimnez Montoya
1030 '***** Ref: Hormign Armado, Montoya-Meseguer-Morn, Ed.G.Gili, Barna
1040 '***** Lenguaje: GW BASIC para compatibles IBM-PC/XT/AT/PS2 en MS-DOS

1050 DEFINT I-J, N: DIM N(4), K(7)
1060 K(1) = .0581: K(2) = .2352: K(3) = .338: K(4) = .5  '*** Coefs. Chebyshev
1070 K(7) = .9419: K(6) = .7648: K(5) = .662
1080 FCD = 1750 * .9 / 1.5: FYD = 4.1 / 1.1: CLS : PRINT '*** Resist. defecto

1090 PRINT "          COMPROBACION DE SOPORTES EN FLEXOCOMPRESION ESVIADA"
1100 T$ = "   Seccin rectangular. Mtodo Parbola-Rectngulo. Clculo riguroso"
1110 S$ = "                     Esfuerzo axil ltimo: Nu =###.## t;  gamc =##.##"
1120 PRINT : PRINT T$
1130 T$ = "1=resistencias   2=escuadra   3=recubr.   4=Armado   5=solicit.   6=fin"
1140 COLOR 0, 7: LOCATE 25, 1: PRINT T$; : COLOR 7, 0: PRINT

1150 WHILE TAREA% < 6
1160    INPUT "                                 Elige opcin = ", TAREA%
1170    IF TAREA% = 1 THEN GOSUB 1230            '*** Resistencias
1180    IF TAREA% = 2 THEN GOSUB 1260            '*** Escuadria
1190    IF TAREA% = 3 THEN GOSUB 1290            '*** Recubrimiento
1200    IF TAREA% = 4 THEN GOSUB 1330            '*** Armado
1210    IF TAREA% = 5 THEN GOSUB 1490            '*** Solicitacion
1220 WEND: END

1230 '*** Resistencias:
1240    INPUT "  Resistencias de clculo:  fcd, fyd (kp/cm2) = ", FCD, FYD
1250    FCD = 10 * FCD: FYD = FYD / 1000        '*** Paso unidades de calculo

1260 '*** Escuadria:
1270    INPUT "        Escuadra de la seccin:  hx, hy (cm) = ", HX, HY
1280    HX = HX / 100: HY = HY / 100             '*** Paso a metros

1290 '*** Recubrimiento:
1300   INPUT "    Recubrimiento mecnico estimado:  r (cm)  = ", RMEC
1310    RMEC = RMEC / 100
1320    FACN = .85 * FCD * HX * HY: FACMY = FACN * HX: FACMX = FACN * HY

1330 '*** Armado:
1340    INPUT "          Cdigo de Armado, dim.: CA,  (mm) = ", CODA%, DIA
1350    NX = CODA% \ 10: NY = CODA% - 10 * NX
1360    NBAR = 2 * (NX + NY) - 4                 '*** Num.barras totales
1370    N(1) = NX: N(2) = NX + NY - 1            '*** Barras de esquina
1380    N(3) = N(2) + NX - 1: N(4) = NBAR
1390    CX = RMEC / HX: CY = RMEC / HY           '*** Recubr. reducidos
1400    EXMIN = HX / 20: IF EXMIN < .02 THEN EXMIN = .02'*** Excentric. mnimas
1410    EYMIN = HY / 20: IF EYMIN < .02 THEN EYMIN = .02
1420    SX = (1 - 2 * CX) / (NX - 1): SY = (1 - 2 * CY) / (NY - 1)'*** Separac. barras reduc.
1430    X = .5 - CX: Y = .5 - CY                 '*** Coord. reduc. 1a barra
1440    DX = -SX: DY = 0                         '*** Paso a la 2a barra
1450    RAG = 180 / 3.14159265#                  '*** Paso radianes/grados
1460    AMIN = 40 * HX * HY / NBAR               '*** Area mnima/barra (cm2)
1470    ABAR = 3.141593 * DIA * DIA / 400        '*** Area real de cada barra
1480    IF ABAR < AMIN THEN PRINT SPACE$(20); "Ojo! No cumple cuanta mnima"

1490 '*** Solicitacion:
1500    INPUT "Solic. act.de clculo: Mxd(hy), Myd(mt), Nd(t)= ", MXD, MYD, ND!
1510    IF MXD < 0 THEN MXD = -MXD               '*** Momentos negativos
1520    IF MYD < 0 THEN MYD = -MYD
1530    IF ND! < 1 THEN ND! = 1                  '*** Axil mnimo

1540    EX = MYD / ND!: EY = MXD / ND!           '*** Excentricidades
1550    IF EX >= EXMIN OR EY >= EYMIN THEN 1620  '*** Excentr. mnimas
1560      IF HX >= HY THEN 1600
1570         EX = EXMIN: MYD = EX * ND!
1580         EY = 0:     MXD = 0
1590      GOTO 1620
1600         EY = EYMIN: MXD = EY * ND!
1610         EX = 0:     MYD = 0

1620    FI = 90                                  '*** Angulo de la resultante
1630    IF EX <> 0 THEN FI = RAG * ATN(EY / EX * HX / HY)
1640    RO = SQR(EX * EX + EY * EY)              '*** Dist. origen (exc. total)
1650    IF RO > SQR(HX * HX + HY * HY) / 2 THEN RO = 1 / RO: KEX = 1 ELSE KEX = 0
1660    BET = FI: XI = .5: GOSUB 1900            '*** Valores iniciales
1670    WHILE ABS(ERRRO) > .001 * RO OR ABS(ERRAN) > .1
1680      XI1 = XI: E5 = ERRRO: XI = XI1 + .1    '*** Nuevo valor de xi
1690      WHILE ABS(ERRRO) > .001 * RO
1700        GOSUB 1900                           '*** Subrutina principal
1710        DXI = (XI1 - XI) / (E5 - ERRRO) * ERRRO  '*** Correccin de xi
1720        IF ABS(DXI) > .1 THEN DXI = .1 * SGN(DXI)'*** Valor mx. correccin
1730       'IF DXI * ERRRO > 0 THEN DXI = -DXI       '*** Cambio de sentido
1740        XI1 = XI: E5 = ERRRO: XI = XI - DXI      '*** Nuevos valores
1750        IF XI > 2 THEN XI = 2                    '*** Valores extremos
1760        IF XI < 0 THEN XI = .01
1770      WEND                                       '*** Nuevo tanteo de xi
1780      BET1 = BET: E6 = ERRAN: BET = BET1 + 9     '*** Nuevo valor de beta
1790      WHILE ABS(ERRAN) > .1
1800        GOSUB 1900                           '*** Subrutina principal
1810        DBET = (BET1 - BET) / (E6 - ERRAN) * ERRAN'*** Correccin de beta
1820        IF ABS(DBET) > 9 THEN DBET = 9 * SGN(DBET)'*** Valor mx. correccin
1830        BET1 = BET: E6 = ERRAN: BET = BET - DBET  '*** Nuevos valores
1840        IF BET > 90 THEN BET = 90                 '*** Valores extremos
1850        IF BET < 0 THEN BET = 0
1860      WEND                                        '*** Nuevo tanteo beta
1870    WEND
1880    PRINT USING S$; NU!, NU! / ND!: PRINT
1890    RETURN                                        '*** Comn a las 5 Subr.

1900 '*** Resultante:                   '*** Subrutina pral: clculo dada f.n.
1910    IF BET <= 45 THEN T = TAN(BET / RAG) ELSE T = TAN((90 - BET) / RAG)
1920    T1 = 1 / (1 + T): T2 = 1 - T1
1930    C = 1 / SQR(1 + T * T): S = T * C            '*** Coseno y seno
1940    D = ((1 - CX) * C + (1 - CY) * S) / (C + S)  '*** Canto til oblicuo

1950    IF XI > 0 THEN 1970
1960       EPSC = 100 * XI: EPSS = -100: GOTO 2050   '*** Dominio 1
1970    IF XI > .259 * D THEN 2000
1980       EPSC = 100 * XI / (D - XI)                '*** Dominio 2
1990       EPSS = -100: GOTO 2050
2000   IF XI > 1 THEN 2030
2010      EPSC = 35                                  '*** Dominios 3 y 4
2020      EPSS = 35 * (XI - D) / XI: GOTO 2050
2030   EPSC = 50 - 15 * XI: EPS = 35 * (1 - D)       '*** Dominio 5
2040   EPSS = EPS + (XI - 1) * (20 - EPS)
2050   DEPS = (EPSC - EPSS) / D / (C + S)

2060   NC! = 0: MXC = 0: MYC = 0                     '*** Resultantes hormign
2070   IF XI < T2 THEN X1 = XI ELSE X1 = T2
2080   GOSUB 2490                                    '*** Subr. Triangulo
2090   IF XI <= T2 THEN 2150
2100      IF XI < T1 THEN X1 = XI ELSE X1 = T1
2110      GOSUB 2670                                 '*** Subr. Paralelogramo
2120      IF XI <= T1 THEN 2150
2130        IF XI < 1 THEN X1 = XI ELSE X1 = 1
2140        GOSUB 2820                               '*** Subr. Trapecio
2150    IF BET <= 45 THEN 2180
2160       M3 = MYC: MYC = MXC: MXC = M3
2170       T = S: S = C: C = T                       '*** Cambio X por Y
2180    NC! = NC! * FACN: MXC = MXC * FACMX
2190    MYC = MYC * FACMY                            '*** Paso reducido a real

2200    NS! = 0: MXS = 0: MYS = 0                    '*** Resultantes acero
2210    U = CX * C + CY * S: DU = C * SX             '*** 1a barra armadura
2220    FOR I = 1 TO NBAR                            '*** Resultantes armaduras
2230        EPS = EPSC - U * DEPS                    '*** Deformacin barra
2240        SIG = .21 * EPS                          '*** Tensin
2250        IF SIG < -FYD THEN SIG = -FYD            '*** Limitaciones tensin
2260        IF SIG > FYD THEN SIG = FYD
2270        NS! = NS! + SIG
2280        MXS = MXS + SIG * Y
2290        MYS = MYS + SIG * X
2300        IF I = N(1) THEN DX = 0: DY = -SY: DU = S * SY   '*** Esquinas
2310        IF I = N(2) THEN DX = SX: DY = 0: DU = -C * SX
2320        IF I = N(3) THEN DX = 0: DY = SY: DU = -S * SY
2330        X = X + DX: Y = Y + DY: U = U + DU       '*** Coordenadas y prof.
2340    NEXT I                                       '*** Barra siguiente
2350    DX = -SX: DY = 0                             '*** 1a barra armadura
2360    NS! = NS! * ABAR: MXS = MXS * ABAR * HY      '*** Paso reducido a real
2370    MYS = MYS * ABAR * HX

2380    NU! = NC! + NS!: MXU = MXC + MXS             '*** Esfuerzos ltimos
2390    MYU = MYC + MYS
2400    EXU = MYU / NU!: EYU = MXU / NU!             '*** Excentr. resultantes
2410    ROU = SQR(EXU * EXU + EYU * EYU)
2420    IF KEX = 1 THEN ROU = 1 / ROU
2430    ERRRO = ROU - RO                             '*** Error radial
2440    IF ABS(EXU) >= .0001 THEN 2470
2450      ERRAN = 90 - FI                            '*** Error angular
2460      GOTO 2480
2470      ERRAN = RAG * ATN(EYU / EXU * HX / HY) - FI
2480    RETURN

2490 '*** Triangulo:                            '*** Resultante hn. tringulo
2500   IF T2 = 0 THEN RETURN
2510   HT = S * X1 / T2                            '*** Altura del tringulo
2520   FOR I = 1 TO 7
2530       U = K(I) * HT                           '*** Prof. de la franja
2540       EPS = EPSC - U * DEPS                   '*** Deformacin hormign
2550       SIG = 1                                 '*** Tensin relativa
2560       IF EPS < 20 THEN AUX = 1 - EPS / 20: SIG = 1 - AUX * AUX
2570       SIG = SIG * K(I)                        '*** Axil franja
2580       NC! = NC! + SIG
2590       MXC = MXC + SIG * (1 - U / S)
2600       MYC = MYC + SIG * (1 - U / C)
2610  NEXT I
2620  FAC = HT * HT / S / C / 14                   '*** Factor
2630  NC! = 2 * NC! * FAC
2640  MXC = MXC * FAC
2650  MYC = MYC * FAC
2660  RETURN

2670 '*** Paralelogramo:                       '*** Resultante zona paralelog.
2680 IF T2 = 0 THEN HT = X1 ELSE HT = S * (X1 / T2 - 1)  '*** Altura paralel.
2690 NP! = 0: MY = 0: X0 = (1 - T) / 2             '*** Abscisa 1a franja
2700 FOR I = 1 TO 7
2710      U = S + K(I) * HT                        '*** Prof. de la franja
2720      EPS = EPSC - U * DEPS                    '*** Deformacin hormign
2730      SIG = 1                                  '*** Tensin relativa
2740      IF EPS < 20 THEN AUX = 1 - EPS / 20: SIG = 1 - AUX * AUX
2750      NP! = NP! + SIG                          '*** Axil franja
2760      MY = MY + SIG * (X0 - (U - S) / C)
2770  NEXT I
2780  FAC = HT / C / 7                             '*** Factor
2790  NC! = NC! + NP! * FAC
2800  MYC = MYC + MY * FAC
2810  RETURN

2820 '*** Trapecio:                             '*** Resultante zona trapecio
2830  IF T2 = 0 THEN RETURN
2840  HT = (C + S) * X1 - C                        '*** Altura del trapecio
2850  NP! = 0: MX = 0: MY = 0
2860  FOR I = 1 TO 7
2870      U = C + K(I) * HT                        '*** Prof. de la franja
2880      EPS = EPSC - U * DEPS                    '*** Deformacin hormign
2890      SIG = 1                                  '*** Tensin relativa
2900      IF EPS < 20 THEN AUX = 1 - EPS / 20: SIG = 1 - AUX * AUX
2910      SIG = SIG * (S - K(I) * HT)              '*** Axil franja
2920      NP! = NP! + SIG
2930      MX = MX + SIG * (C - U) / S
2940      MY = MY + SIG * (S - U) / C
2950  NEXT I
2960  FAC = HT / S / C / 14                        '*** Factor
2970  NC! = NC! + NP! * 2 * FAC
2980  MXC = MXC + MX * FAC
2990  MYC = MYC + MY * FAC
3000  RETURN
