1010 '***** PROGRAMA DM2P: DIMENSIONAMTO SOPORTE ESBELTO FLEXCOMPR.ESVIADA
1020 '***** Autores: F.Morn Cabr - A.Garca Meseguer - P.Jimnez Montoya
1030 '***** Ref: Hormign Armado, Montoya-Meseguer-Morn, Ed.G.Gili, Barna
1040 '***** Lenguaje: GW BASIC para compatibles IBM-PC/XT/AT/PS2 en MS-DOS

1050 DEFINT I-J, N
1060 DIM EX(10), EY(10), CUX(10), CUY(10), EPSU(10), K(7), X(32), Y(32)
1070 K(1) = .0581: K(2) = .2352: K(3) = .338: K(4) = .5  '*** Coefs. Chebyshev
1080 K(7) = .9419: K(6) = .7648: K(5) = .662
1090 ROMIN = 40                                          '** Cuanta geom. mn.
1100 FCD = 1750 * .9 / 1.5: FYD = 4.1 / 1.1       '** Resistencias por defecto
1110 EYD = FYD / .21                              '** Deformac. lmite elstico

1120 CLS : PRINT
1130 T$ = "Tanteo n ## con w = #.###: "
1140 T1$ = "     DIMENSIONAMIENTO SOPORTES ESBELTOS A FLEXION ESVIADA Y PANDEO"
1150 T2$ = "     Seccin rectangular. Mtodo General Exacto. Clculo riguroso"
1160 T3$ = "1=resistencias  2=dimens.sop  3=recubr.  4=Cd.Armado  5=solicitac. 6=fin"
1170 T4$ = SPACE$(20) + "Capacidad mecnica/barra: U =###.## t;   =###.## mm"
1180 PRINT T1$: PRINT : PRINT T2$
1190 COLOR 0, 7: LOCATE 25, 1: PRINT T3$; : COLOR 7, 0

1200 WHILE TAREA% < 6
1210  PRINT
1220  INPUT "                                   Elige opcin = ", TAREA%
1230  IF TAREA% = 1 THEN GOSUB 1290      ' *** Resistencias
1240  IF TAREA% = 2 THEN GOSUB 1330      ' *** Escuadria
1250  IF TAREA% = 3 THEN GOSUB 1410      ' *** Recubrimiento
1260  IF TAREA% = 4 THEN GOSUB 1440      ' *** Codigo Armado
1270  IF TAREA% = 5 THEN GOSUB 1590      ' *** Solicitacion
1280 WEND: END

1290 ' *** Resistencias:
1300  INPUT "    Resistencias de calculo : fcd, fyd (kp/cm2) = ", FCD, FYD
1310  FCD = FCD * 10: FYD = FYD / 1000         '*** Paso a unidades de clculo
1320  EYD = FYD / .21

1330 ' *** Escuadria:
1340  INPUT "           Escuadra de la seccin: hx, hy (cm) = ", HX, HY
1350  HX = HX / 100: HY = HY / 100             '*** Paso a metros
1360  EMINX = HX / 20: IF EMINX < .02 THEN EMINX = .02'** Exc. mnimas
1370  EMINY = HY / 20: IF EMINY < .02 THEN EMINY = .02
1380  UC = FCD * HX * HY: UCM = .85 * UC       '** Capac. mecn. horm.
1390  INPUT "        Longitud de pandeo del soporte: lo (cm) = ", L0
1400  L0 = L0 / 100: DL = L0 / 20

1410 ' *** Recubrimiento:
1420  INPUT "        Recubrimiento mecnico estimado: r (cm) = ", R: REC = R / 100
1430    RECX = REC / HX: RECY = REC / HY       '** Recubr. relativos

1440 ' *** Cod.Armado:
1450  INPUT "            Cdigo de Armado:  C A ( 2 cifras ) = ", CA%
1460    NX = CA% \ 10: NY = CA% - 10 * NX
1470    NUMBAR = 2 * (NX + NY) - 4             '** Nm. total barras
1480    N1 = NX: N2 = NX + NY - 1: N3 = 2 * NX + NY - 2   '** Barras esquina
1490    SX = (1 - 2 * RECX) / (NX - 1)
1500    SY = (1 - 2 * RECY) / (NY - 1)         '** Separac. barras
1510    X(1) = .5 - RECX: Y(1) = .5 - RECY     '** Coordenadas de barras
1520    DX = -SX: DY = 0
1530    FOR I = 1 TO NUMBAR% - 1
1540      IF I = N1 THEN DX = 0: DY = -SY: GOTO 1570
1550      IF I = N2 THEN DX = SX: DY = 0: GOTO 1570
1560      IF I = N3 THEN DX = 0: DY = SY
1570      X(I + 1) = X(I) + DX: Y(I + 1) = Y(I) + DY
1580    NEXT I

1590 ' *** Solicitacion:
1600  INPUT "Solicit. act. de clculo: Mxd, Myd (mt), Nd (t) = ", MXD, MYD, ND!
1610  IF MXD < 0 THEN MXD = -MXD
1620  IF MYD < 0 THEN MYD = -MYD
1630  IF ND! < 1 THEN ND! = 1
1640  EX0 = MYD / ND!: IF EX0 < 0 THEN EX0 = -EX0  '** Exc. sec. central
1650  EY0 = MXD / ND!: IF EY0 < 0 THEN EY0 = -EY0
1660  IF EX0 >= EMINX OR EY0 >= EMINY THEN 1730    '** Condic. de exc.mn.
1670    IF HX >= HY THEN 1710
1680      EX0 = EMINX: MYD = EX0 * ND!
1690      EY0 = 0:   MXD = 0
1700      GOTO 1730
1710      EX0 = 0:   MYD = 0
1720      EY0 = EMINY: MXD = EY0 * ND!

1730  WINF = ROMIN * FYD / FCD                     '** Cuanta mec. mn.
1740  WSUP = 2 - WINF                              '** Cuanta mec. sup.
1750  PRIMERA% = 1: ITANT = 0
1760  WHILE WSUP - WINF > .002 AND WINF < .999
1770    W = (WINF + WSUP) / 2                      '** Cuanta ensayada
1780    ABAR = W * UC / FYD / NUMBAR               '** Area de una barra
1790    INEST = 0: AGOT% = 0: CONVERGE% = 0: ITANT = ITANT + 1
1800    WHILE CONVERGE% = 0 AND INEST < 3 AND AGOT% < 3
1810       GOSUB 2020
1820       PRIMERA% = 0
1830       IF ABS(EXF - EX0) > .001 OR ABS(EYF - EY0) > .001 THEN CONVERGE% = 0
1840    WEND
1850    LOCATE 24, 30: PRINT USING T$; ITANT, W;
1860    IF AGOT% = 0 THEN 1890
1870      PRINT "Agotamiento;  ";
1880      WINF = W: PRIMERA% = 1: GOTO 1940
1890    IF INEST <> 3 THEN 1920
1900      PRINT "Inestabilidad;";
1910      WINF = W: PRIMERA% = 1: GOTO 1940
1920      PRINT "Convergencia; ";
1930      WSUP = W
1940 WEND
1950 IF WINF <= .999 THEN 1980
1960   PRINT "No cumple con w=1. Aumentar seccin";
1970   GOTO 2010
1980   ABAR = WSUP * UC / FYD / NUMBAR
1990   FI = 20 * SQR(ABAR / 3.1416)
2000   LOCATE 24, 1: PRINT USING T4$; ABAR * FYD; FI
2010 RETURN

2020 '** PIEZA:
2030 '** A partir de unos valores de las excentricidades en la sec. central
2040 '** ex(0), ey(0), calcula los de la seccin extrema  ex(10), ey(10)
2050 CONVERGE% = 1
2060 IF PRIMERA% = 0 THEN 2100
2070   CXC = MXD / 290 / HX / HY / HY / HY * 12
2080   CYC = MYD / 290 / HY / HX / HX / HX * 12
2090   EPSO = 3: EX(0) = EX0: EY(0) = EY0        '** Valores de partida
2100 IF PRIMERA% = 1 THEN 2170
2110   IF EXF = 0 THEN EX(0) = 0: GOTO 2140      '** Nuevos val. partida
2120   IF EX0 / EXF < .8 THEN EX(0) = EX(0) * .8: GOTO 2140
2130   EX(0) = EX(0) * EX0 / EXF
2140   IF EYF = 0 THEN EY(0) = 0: GOTO 2170
2150   IF EY0 / EYF < .8 THEN EY(0) = EY(0) * .8: GOTO 2170
2160   EY(0) = EY(0) * EY0 / EYF

2170 FOR ISE = 0 TO 9
2180   MXS = EY(ISE) * ND!: MYS = EX(ISE) * ND!  '** Mom. exteriores sec.
2190   IF PRIMERA% = 0 THEN 2220
2200     CX = CXC: CY = CYC: EPSOI = EPSO        '** Valores supuestos
2210     GOTO 2230
2220     CX = CUX(ISE): CY = CUY(ISE): EPSOI = EPSU(ISE)
2230   GOSUB 2380
2240   CUX(ISE) = CXC: CUY(ISE) = CYC
2250   EPSU(ISE) = EPSO                          '** Valores correg.
2260   IF ISE > 0 THEN 2300
2270     EX(1) = EX(0) - DL * DL / 2 * CYC / 10000'** Exc. sec. sgte.
2280     EY(1) = EY(0) - DL * DL / 2 * CXC / 10000
2290     GOTO 2320
2300     EX(ISE + 1) = 2 * EX(ISE) - EX(ISE - 1) - DL * DL * CYC / 10000
2310     EY(ISE + 1) = 2 * EY(ISE) - EY(ISE - 1) - DL * DL * CXC / 10000
2320 NEXT ISE

2330 IF (EX(10) < EXF) OR (EY(10) < EYF) THEN INEST = INEST + 1 ELSE INEST = 0
2340 EXF = EX(10): EYF = EY(10)
2350 'PRINT USING "###.#####"; exf, eyf          '** Exc. sec. extr
2360 IF (EXF < 0) OR (EYF < 0) THEN INEST = 3
2370 RETURN  '** PIEZA

2380 '** CORRIGE:
2390 '** Dadas unas curvaturas estimadas cx,cy en una seccin las corrige
2400 '** en funcin de la relacin de los momentos reales en la seccin,
2410 '** Mxs, Mys, a los resultantes Mx, My del clculo de seccin directo
2420 '** SECDIR, obteniendo las nuevas curvaturas cxc, cyc
2430 EPSO1 = EPSOI: EPSO2 = EPSOI + .001         '** Valores tanteo
2440 EPSO = EPSO1: GOSUB 2680: ERRO1 = ERRN: ERRO2 = ERRN
2450 WHILE ABS(ERRO2) > .001                     '** Mtodo de la cuerda
2460   EPSO = EPSO2: GOSUB 2680: ERRO2 = ERRN
2470   'PRINT USING "#####.###"; epso, cx, cy, N!, Mx, My
2480   DEPSO = (EPSO1 - EPSO2) / (ERRO1 - ERRO2) * ERRO2
2490   IF DEPSO < -10 THEN DEPSO = -10
2500   IF DEPSO > 10 THEN DEPSO = 10
2510   EPSO1 = EPSO2: ERRO1 = ERRO2: EPSO2 = EPSO2 - DEPSO
2520 WEND
2530 IF ISE > 0 THEN 2570
2540   EPSP = (EPSS * 3 / 7 + EPSC * (4 / 7 - R)) / D'** Def. pivote C, domin. 5  **
2550   IF (EPSC > 35) OR (EPSS < -100) OR (EPSP > 20) THEN AGOT% = AGOT% + 1 ELSE AGOT% = 0   '** Condic. de agotamiento**
2560   'PRINT USING"###.###";epsc,epss,epsp
2570 IF MXS = 0 THEN 2610
2580    CXC = CX * MXS / MX                      '** Curvat. corregidas
2590    IF ABS(MXS / MX - 1) > .002 THEN CONVERGE% = 0
2600    GOTO 2620
2610    CXC = 0
2620 IF MYS = 0 THEN 2660
2630    CYC = CY * MYS / MY
2640    IF ABS(MYS / MY - 1) > .002 THEN CONVERGE% = 0
2650    GOTO 2670
2660    CYC = 0
2670 RETURN   '** CORRIGE

2680 '** SECDIR:
2690 '** Clculo de Seccin Directo: Dados la def. epso (centro seccin)
2700 '** y las curvaturas cx, cy obtiene los esfuerzos  N!, Mx, My
2710 CXR = CX * HY: CYR = CY * HX                '** Curvaturas reducidas
2720 EPSC = EPSO + .5 * CXR + .5 * CYR           '**Def. esquina ms compr.
2730 EPSS = EPSO - (.5 - RECX) * CYR - (.5 - RECY) * CXR '**Def.arm. ms tracc.
2740 IF CXR > CYR THEN RECU = RECX: RECX = RECY: RECY = RECU: T = CYR / CXR ELSE T = CXR / CYR
2750                                             '** t = tan (alfa) en sec. 1x1
2760 T1 = 1 / (1 + T): T2 = 1 - T1
2770 C = 1 / SQR(1 + T * T): S = T * C     '** c = cos(alfa); s = sin(alfa)
2780 D = ((1 - RECX) * C + (1 - RECY) * S) / (C + S)'** d = canto til relat.
2790 DEPS = (EPSC - EPSS) / D / (C + S)    '** deps = gradiente de deformac.
2800 L = EPSC / (EPSC - EPSS) * D          '** l = prof. relativa eje neutro
2810 R = 1 - D                             '** r = recubr. relativo

2820 N! = 0: MX = 0: MY = 0                '** Clculo resultantes hormign
2830 IF L <= 0 THEN 2950
2840   IF L >= T2 THEN 2860
2850     X1 = L: GOSUB 3170: GOTO 2950
2860   IF L >= T1 THEN 2880
2870     X1 = T2: GOSUB 3170: X1 = L: GOSUB 3310: GOTO 2950
2880   IF L >= 1 THEN 2920
2890     X1 = T2: GOSUB 3170
2900     X1 = T1: GOSUB 3310
2910     X1 = L: GOSUB 3450: GOTO 2950
2920     X1 = T2: GOSUB 3170
2930     X1 = T1: GOSUB 3310
2940     X1 = 1: GOSUB 3450
2950 IF CXR <= CYR THEN 2980
2960     MZ = MX: MX = MY: MY = MZ
2970     T = S: S = C: C = T: RECU = RECX: RECX = RECY: RECY = RECU
2980 N! = N! * UCM: MX = MX * UCM * HY: MY = MY * UCM * HX

2990 NA! = 0: MXA = 0: MYA = 0             '** Clculo resultantes armaduras
3000 EPS = EPSC - (RECX * C + RECY * S) * DEPS: DDEPS = C * SX * DEPS
3010 FOR I = 1 TO NUMBAR%
3020   IF EPS > EYD THEN SGR = FYD: GOTO 3050
3030   SGR = .21 * EPS
3040   IF SGR < -FYD THEN SGR = -FYD
3050   NA! = NA! + SGR: MXA = MXA + Y(I) * SGR: MYA = MYA + X(I) * SGR
3060   IF I <> N1 THEN 3080
3070     DDEPS = S * SY * DEPS: GOTO 3120
3080   IF I <> N2 THEN 3100
3090     DDEPS = -C * SX * DEPS: GOTO 3120
3100   IF I <> N3 THEN 3120
3110     DDEPS = -S * SY * DEPS
3120   EPS = EPS - DDEPS
3130 NEXT I
3140 N! = N! + NA! * ABAR: MX = MX + MXA * ABAR * HY: MY = MY + MYA * ABAR * HX
3150 ERRN = (N! - ND!) / ND!               '** Error en axiles
3160 RETURN '** SECDIR

3170 '** TRIANGULO:                        '** Zona comprimida triangular
3180 IF T <= 0 THEN RETURN
3190 H = S * X1 / T2                       '** Profundidad de la zona
3200 FOR I = 1 TO 7
3210   Z = K(I) * H                        '** Prof. de la fibra
3220   EPS = EPSC - Z * DEPS               '** Deform. de la fibra
3230   IF EPS > 20 THEN SIGC = 1 ELSE F = 1 - EPS / 20: SIGC = 1 - F * F
3240   NFB! = SIGC * K(I)                  '** Axil de la fibra
3250   N! = N! + NFB!: MX = MX + NFB! * (1 - Z / S)
3260   MY = MY + NFB! * (1 - Z / C)
3270 NEXT I
3280 FACTOR = H * H / S / C / 14
3290 N! = 2 * FACTOR * N!: MX = FACTOR * MX: MY = FACTOR * MY
3300 RETURN  '**TRIANGULO

3310 '** PARALELOGRAMO:                    '** Zona comprimida paralelog.
3320 IF T = 0 THEN H = X1 ELSE H = S * (X1 / T2 - 1)
3330 X0 = (1 - T) / 2
3340 DN = 0: DMY = 0
3350 FOR I = 1 TO 7
3360   Z = S + K(I) * H
3370   EPS = EPSC - Z * DEPS
3380   IF EPS > 20 THEN SIGC = 1 ELSE F = 1 - EPS / 20: SIGC = 1 - F * F
3390   NFB! = SIGC
3400   DN = DN + NFB!: DMY = DMY + NFB! * (X0 - (Z - S) / C)
3410 NEXT I
3420 FACTOR = H / C / 7
3430 N! = N! + FACTOR * DN: MY = MY + FACTOR * DMY
3440 RETURN  '**PARALELOGRAMO

3450 '** TRAPECIO:                         '** Zona comprimida trapecio
3460 IF T <= 0 THEN RETURN
3470 H = (C + S) * X1 - C
3480 DN = 0: DMX = 0: DMY = 0
3490 FOR I = 1 TO 7
3500   Z = C + K(I) * H
3510   EPS = EPSC - Z * DEPS
3520   IF EPS > 20 THEN SIGC = 1 ELSE F = 1 - EPS / 20: SIGC = 1 - F * F
3530   NFB! = SIGC * (S - K(I) * H)
3540   DN = DN + NFB!: DMX = DMX + NFB! * (C - Z) / S
3550   DMY = DMY + NFB! * (S - Z) / C
3560 NEXT I
3570 FACTOR = H / S / C / 14
3580 N! = N! + 2 * FACTOR * DN: MX = MX + FACTOR * DMX: MY = MY + FACTOR * DMY
3590 RETURN '**TRAPECIO
